=== debian/changelog ===
mupdf (1.19.0+ds1-2) unstable; urgency=medium

  * d/watch: Follow HTTP redirect
  * Depend on minimum runtime version of jbig2 (Closes: #1005788)

  [ Pino Toscano ]
  * Drop mupdf.xpm, as it was needed for the Debian menu
  * Install app icon in XDG hicolor icon theme
  * Install app icon from docs

 -- Bastian Germann <bage@debian.org>  Tue, 15 Feb 2022 11:33:58 +0100

mupdf (1.19.0+ds1-1) unstable; urgency=medium

  * Revert "Build-Conflict with libssl" (Closes: #969301, #783648, #971449)
  * Depend on libgumbo
  * Update debhelper to v13
  * Refresh patches for v1.19.0
  * d/control: Add Uploader bage
  * d/copyright: Update to match 1.19.0
  * d/copyright: Exclude all thirdparty except 'extract'
  * New upstream version 1.19.0+ds1 (Closes: #974736, #968699)
  * Specifiy jbig2dec version (Closes: #970828)
  * Add missing executables (Closes: #914396)

  [ Jörg-Volker Peetz ]
  * mupdf.sh: Compression with zstandard; replace tempfile (Closes: #968133)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Celejar ]
  * Only warn once about the missing ICC support (Closes: #952724)

 -- Bastian Germann <bage@debian.org>  Tue, 26 Oct 2021 04:05:12 +0200
