=== platform/java/Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 JAVA_CFLAGS := \
 	-I $(JAVA_VM)/include \
 	-I $(JAVA_VM)/include/darwin
-JAVA_LDFLAGS :=
+JAVA_LDFLAGS := -lstdc++
 
 else
 
@@ -50,22 +50,25 @@
 JAVA_LDFLAGS := \
 	-z noexecstack
 
-ifeq ($(USE_TESSERACT), yes)
+ifeq ($(tesseract), yes)
 ifeq ($(USE_SYSTEM_TESSERACT), yes)
 JAVA_LIBS += \
 	$(shell pkg-config --libs lept) \
 	$(shell pkg-config --libs tesseract)
 
-CONFIGFLAGS += USE_SYSTEM_TESSERACT=yes
+CONFIGFLAGS += tesseract=yes USE_SYSTEM_TESSERACT=yes
 else
-CONFIGFLAGS += USE_TESSERACT=yes
+CONFIGFLAGS += tesseract=yes
 endif
 endif
 endif
 
 MUPDF_JAR := ../../$(OUT)/libmupdf.jar
 
-default: $(MUPDF_JAVA) $(MUPDF_JAR) $(EXAMPLE_JAVA_SOURCES)
+EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
+EXAMPLE_JAVA_OBJECTS := $(subst example/,../../$(OUT)/example/,$(EXAMPLE_JAVA_SOURCES:%.java=%.class))
+
+default: $(MUPDF_JAVA) $(MUPDF_JAR) $(EXAMPLE_JAVA_OBJECTS)
 
 MUPDF_CORE := ../../$(OUT)/libmupdf.a ../../$(OUT)/libmupdf-third.a
 ifeq "$(OS)" "Linux"
@@ -85,9 +88,6 @@
 $(LIBRARY_JAVA_OBJECTS) : $(LIBRARY_JAVA_SOURCES)
 	mkdir -p ../../$(OUT)
 	$(JAVAC) $(JAVAC_FLAGS) -h ../../$(OUT)/ -d ../../$(OUT)/ $^
-
-EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
-EXAMPLE_JAVA_OBJECTS := $(subst example/,../../$(OUT)/example/,$(EXAMPLE_JAVA_SOURCES:%.java=%.class))
 
 $(EXAMPLE_JAVA_OBJECTS): $(EXAMPLE_JAVA_SOURCES)
 	$(JAVAC) $(JAVAC_FLAGS) -classpath ../../$(OUT) -d ../../$(OUT)/ $^
@@ -123,6 +123,7 @@
 	rm -fr ../../$(OUT)/thirdparty
 	rm -f $(MUPDF_JAR)
 	rm -f $(MUPDF_JAVA)
+	rm -f $(MUPDF_CORE)
 	rm -f ../../$(OUT)/*.h
 
 nuke: clean
