=== debian/changelog ===
mupdf (1.20.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.20.0+ds1
  * Drop one unnecessary patch hunk
  * d/copyright: Reflect new version's changes

 -- Bastian Germann <bage@debian.org>  Sat, 18 Jun 2022 21:58:29 +0200
