## mupdf 1.20.3+ds1

=== debian/changelog ===
mupdf (1.20.3+ds1-1) unstable; urgency=medium

  * New upstream version 1.20.3+ds1

 -- Bastian Germann <bage@debian.org>  Mon, 15 Aug 2022 23:07:44 +0200
