## mupdf 1.21.0+ds1

=== debian/changelog ===
mupdf (1.21.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.21.0+ds1
  * Fix lintian by test compiling with hardening flags
  * Add LDFLAGS to test compile
  * d/copyright: Remove zlib license

 -- Bastian Germann <bage@debian.org>  Tue, 08 Nov 2022 20:45:48 +0100
