=== debian/changelog ===
mupdf (1.21.1+ds1-2) unstable; urgency=medium

  * Team upload
  * Add fallback for missing SA_NOCLDWAIT (Closes: #1028919)

  [ Debian Janitor ]
  * Trim trailing whitespace
  * Use secure URI in Homepage field
  * Update standards version to 4.6.2, no changes needed

 -- Bastian Germann <bage@debian.org>  Sun, 15 Jan 2023 01:38:15 +0100

mupdf (1.21.1+ds1-1) unstable; urgency=medium

  * New upstream version 1.21.1

 -- Bastian Germann <bage@debian.org>  Thu, 15 Dec 2022 21:01:30 +0100
