=== debian/rules ===
--- 
+++ 
@@ -56,7 +56,7 @@
 	dh_auto_install -- $(BUILD_FLAGS)
 	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	make -C $(CURDIR)/debian/tests test
+	$(MAKE) -C $(CURDIR)/debian/tests test
 endif
 
 override_dh_auto_clean:
